import * as mc from "@minecraft/server"
const validBlocks = [ 
  "minecraft:coal_ore", 
  "minecraft:copper_ore", 
  "minecraft:deepslate_coal_ore", 
  "minecraft:deepslate_copper_ore", 
  "minecraft:deepslate_diamond_ore", 
  "minecraft:deepslate_emerald_ore", 
  "minecraft:deepslate_gold_ore", 
  "minecraft:deepslate_iron_ore", 
  "minecraft:deepslate_lapis_ore", 
  "minecraft:deepslate_redstone_ore",
  "minecraft:diamond_ore", 
  "minecraft:emerald_ore", 
  "minecraft:gold_ore", 
  "minecraft:iron_ore", 
  "minecraft:lapis_ore", 
  "minecraft:nether_gold_ore", 
  "minecraft:quartz_ore", 
  "minecraft:redstone_ore" ]
const validItems = [
    "minecraft:wooden_pickaxe",
    "minecraft:stone_pickaxe",
    "minecraft:iron_pickaxe",
    "minecraft:golden_pickaxe",
    "minecraft:diamond_pickaxe",
    "minecraft:netherite_pickaxe"
]
mc.world.beforeEvents.playerBreakBlock.subscribe(data => {
  const player = data.player,
        block = data.block;

  const inventoryComponent = player.getComponent(mc.EntityInventoryComponent.componentId);
  const item = inventoryComponent.container.getItem(player.selectedSlotIndex);

  // Verifica se o item na mão é um machado e se o bloco quebrado é um dos logs válidos
  if (!validItems.includes(item?.typeId) || !validBlocks.includes(block.permutation.type.id)) return;

  // Inicia o processo de quebrar blocos adjacentes do mesmo tipo
  breakNearbyLogs(block, player, block.permutation.type.id, 50);
});

function breakNearbyLogs(initialBlock, player, originalBlockType, maxDepth = 5) {
  const visited = new Set();

  function breakAndCheck(block, player, depth) {
    if (!block || depth > maxDepth || block.permutation.type.id !== originalBlockType) {
      return;
    }

    const blockKey = `${block.location.x},${block.location.y},${block.location.z}`;

    if (visited.has(blockKey)) {
      return;
    }

    visited.add(blockKey);

    // Destrói o bloco atual
    block.dimension.runCommandAsync(`fill ${block.location.x} ${block.location.y} ${block.location.z} ${block.location.x} ${block.location.y} ${block.location.z} air destroy`);

    // Define as direções para checar blocos adjacentes
    const locations = [
      { x: 1, y: 0, z: 0 },
      { x: -1, y: 0, z: 0 },
      { x: 0, y: 1, z: 0 },
      { x: 0, y: -1, z: 0 },
      { x: 0, y: 0, z: 1 },
      { x: 0, y: 0, z: -1 }
    ];

    // Checa os blocos adjacentes
    for (const pos of locations) {
      const adjacentBlock = block.dimension.getBlock({
        x: block.location.x + pos.x,
        y: block.location.y + pos.y,
        z: block.location.z + pos.z
      });

      breakAndCheck(adjacentBlock, player, depth + 1);
    }
  }

  breakAndCheck(initialBlock, player, 0);
}
                          
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                
                                        
                           
                
                
                            
                                  
                
                
                
                
                
                
                
                
                
                                
                
                
                
                
                
                
                
                
                
                
                
                
                
                           
                
                
                 
                            
                
                
                
                
                
                
                           
                
                
                            
                                      
                                     
                                      
                                          
                
                
                
                
                
                
                
                
                
                
                
                
                
                           
                
                
                 
                            
                
                
                
                
                
                
                           
                
                
                            
                                      
                             
                
                
                
                
                
                
                
                                
                
                
                
                
                
                
                
                
                
                
                
                
                
                           
                
                
                 
                            
                
                
                
                
                
                
                           
                
                
                            
                                  
                
                
                
                
                
                
                
                
                
                                
                
                
                
                
                
                
                
                
                
                
                
                
                
                           
                
                
                 
                            
                
                
                
                
                
                
                           
                
                
                            
                                      
                                                                            
                            
                                      
                                                                                                                          
                            
                                      
                                                                        
                
                
                
                
                           
                
                
                            
                                      
                                                                            
                            
                                      
                                                                        
                
                
                            
                                      
                                                                            
                            
                                      
                                                                                                                                                         